/*
 * Firedoclipse
 * 
 * Copyright (c) 2007-2008 Massachusetts Institute of Technology
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package firedoclipse;

import java.rmi.ConnectException;

import jsjr.*;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;

/**
 * The activator class controls the plug-in life cycle.
 * 
 * @author maxg
 */
public class Activator extends AbstractUIPlugin implements ConnectionListener {
    
    public static final String PLUGIN_ID = "edu.mit.csail.uid.firedoclipse";
    
    private static final String PORT = "FIREDOCLIPSE_CONNECTOR_PORT";
    
    private static Activator plugin;
    
    private Connector connector;
    
    private Connection connection = new Connection() {
        public void call(String remoteId, String method, Marshalable... arguments) { }
    };
    
    public Activator() { }
	
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
		
		connector = new ConnectorImpl(System.getenv(PORT) == null ? 3945 : Integer.parseInt(System.getenv(PORT)));
		connector.addConnectionListener(this);
		connector.accept();
	}
	
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		
		try {
	        connector.close();
		} finally {
		    super.stop(context);
		}
	}
	
	public static Activator getDefault() {
		return plugin;
	}

    public void connected(Connection connection) {
        this.connection = connection;
        try {
            connection.call("@csail.mit.edu/firedoclipse/Browse;1",
                            "eclipseVersionIs",
                            ConnectorImpl.marshalable((String)getBundle().getHeaders().get(Constants.BUNDLE_VERSION)));
        } catch (ConnectException ce) { }
    }
    
    public Connection connection() {
        return connection;
    }
}
