/*
 * Firedoclipse
 * 
 * Copyright (c) 2007-2008 Massachusetts Institute of Technology
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const Cc = Components.classes;
const Ci = Components.interfaces;
const log = function(){};

const PORT = "FIREDOCLIPSE_CONNECTOR_PORT";

function Activator() {
    log("Activator()\n");
    this.wrappedJSObject = this;
}

Activator.prototype = {
    classDescription: "Firedoclipse activator",
    classID:          Components.ID("{3734f2d0-c94b-11dd-ad8b-0800200c9a66}"),
    contractID:       "@csail.mit.edu/firedoclipse/Activator;1",
    QueryInterface:   XPCOMUtils.generateQI(),
    
    connector: function() {
        return Cc["@csail.mit.edu/jsjr/connector;1"].getService().wrappedJSObject;
    },
    
    window: function(window) {
        log("Activator.window(" + window + ")\n");
        
        var connector = this.connector();
        var env = Cc["@mozilla.org/process/environment;1"].getService(Ci.nsIEnvironment);
        var port = (env.exists(PORT) ? env.get(PORT) : 3945);
        window.document.getElementById("appcontent").addEventListener("load", function(e) {
            connector.asyncConnect(port);
        }, true);
    }
}

function NSGetModule(compMgr, fileSpec) { return XPCOMUtils.generateModule([ Activator ]) };
